
//definire una matrice dinamica e calcolare la somma degli elementi della matrice

#include <stdio.h>
#include <stdlib.h>

int main ()
{
    int **mat;
    int i,j,r,c,som=0;
    printf ("Inserisci il numero di righe > ");
    scanf ("%d",&r);
    printf ("Inserisci il numero di colonne > ");
    scanf ("%d",&c);
    printf ("Provo ad allocare la memoria richiesta...\n");
    mat=(int**) malloc (r*sizeof(int*));
    if (mat==NULL)
    {
        printf ("MEMORIA NON DISPONIBILE! \n");
        exit (-1);
    }
    else
    {
        for (i=0;i<r;i++)
        {
            mat[i]=(int*) malloc (c*sizeof(int));
            if (mat[i]==NULL)
            {
                printf ("MEMORIA NON DISPONIBILE! \n");
                free(mat);
                exit(-1);
            }
        }//for malloc
        printf ("la memoria e' stata allocata con successo! \n\n");
        printf ("CARICAMENTO MATRICE \n");
        for (i=0;i<r;i++)
        {
            for (j=0;j<c;j++)
            {
                printf ("Inserisci elemento [%d,%d] > ",i,j);
                scanf ("%d",&mat[i][j]);
            }
        }//for inserimento
        printf ("\n");
        printf ("LA MATRICE INSERITA E' \n");
        for (i=0;i<r;i++)
        {
            for (j=0;j<c;j++)
            {
                // I due printf seguenti sono equivalenti
                // il primo sfrutta la notazione degli array
                // il secondo la notazione dei puntatori
                
                // printf ("%d\t", mat[i][j] );
                printf ("%d\t", *((*(mat+i))+j) );
            }
            printf ("\n");
        }//for print
        printf ("\n");
        printf ("CALCOLO SOMMA ELEMENTI \n");
        for (i=0;i<r;i++)
        {
            for (j=0;j<c;j++)
            {
                som+=mat[i][j];
            }
        }
        printf ("somma: %d \n",som);
    }//else
    printf ("Libero la memoria... \n");
    for (i=0;i<r;i++)
    {
        free(mat[i]);
    }
    free(mat);
}
